<?php
    ob_start();
    define( 'K_ADMIN', 1 );

    if ( defined('K_COUCH_DIR') ) die; // is meant to be invoked directly only
    define( 'K_COUCH_DIR', str_replace( '\\', '/', dirname(dirname(realpath(__FILE__))).'/') );

    require_once( K_COUCH_DIR.'header.php' );
    header( 'Content-Type: text/html; charset='.K_CHARSET );

    $AUTH = new KAuth( K_ACCESS_LEVEL_ADMIN );

    echo my_up_down( 'asc' ); // order should match the display order of pages in list



    /////

    function my_up_down( $sort='desc' /* order of display of pages in list */ ){
        global $FUNCS, $CTX, $DB;

        if( !$FUNCS->is_non_zero_natural($_GET['tpl']) || !$FUNCS->is_non_zero_natural($_POST['id']) || !$FUNCS->is_natural($_POST['dir'])){
            die( 'ERROR: invalid input' );
        }
        $tpl_id = intval( $_GET['tpl'] );
        $page_id = intval( $_POST['id'] );
        $dir = intval( $_POST['dir'] );
        $fid = ( isset($_GET['fid']) && $FUNCS->is_non_zero_natural($_GET['fid']) ) ? (int)$_GET['fid'] : null;

        $FUNCS->validate_nonce( 'updown_page_'.$tpl_id );

        // get template
        $rs = $DB->select( K_TBL_TEMPLATES, array('name'), "id='" . $DB->sanitize( $tpl_id ). "'" );
        if( !count($rs) ) die( 'Template not found' );
        $tpl_name = $rs[0]['name'];

        // get selected page
        $sql0 = "template_id='" . $DB->sanitize( $tpl_id ). "'";
        $sql1 .= " AND id='".$DB->sanitize( $page_id )."'";
        $sql2 = '';
        if( $fid ){
            // if this is a parent-folder include all child folders in query too
            $folders = &$FUNCS->get_folders_tree( $tpl_id, $tpl_name );
            $arr_folders = array();
            $f = &$folders->find_by_id( $fid );
            if( $f ){
                $sub_folders = $f->get_children();
                foreach( $sub_folders as $sf ){
                    $arr_folders[$sf->name] = $sf->id;
                }
            }
            if( count($arr_folders) ){
                $sql2 = " AND ";
                $sql2 .= "(";
                $sep = "";
                foreach( $arr_folders as $k=>$v ){
                    $sql2 .= $sep . "page_folder_id='" . $DB->sanitize( $v )."'";
                    $sep = " OR ";
                }
                $sql2 .= ")";
            }
        }
        $sql = $sql0 . $sql1 . $sql2;
        $rs = $DB->select( K_TBL_PAGES, array('publish_date'), $sql0.$sql1.$sql2 );
        if( !count($rs) ) die( 'Page not found' );
        $date_1 = $rs[0]['publish_date'];

        // get adjacent page
        if( $sort=='desc' ){
            $op = ($dir) ? '>' : '<';
            $order = ($dir) ? 'asc' : 'desc';
        }
        else{
            $op = ($dir) ? '<' : '>';
            $order = ($dir) ? 'desc' : 'asc';
        }
        $sql = $sql0 . " AND publish_date ". $op ." '" . $DB->sanitize( $date_1 ). "'" . $sql2;
        $sql .= " ORDER BY publish_date ".$order." LIMIT 0, 1";

        $rs = $DB->select( K_TBL_PAGES, array('id', 'publish_date'), $sql );

        // if found, swap dates
        if( count($rs) ){
            $page_id_2 = $rs[0]['id'];
            $date_2 = $rs[0]['publish_date'];

            $DB->begin();
            $DB->update( K_TBL_PAGES, array('publish_date'=>$date_2), "id='" . $DB->sanitize( $page_id ). "'" );
            $DB->update( K_TBL_PAGES, array('publish_date'=>$date_1), "id='" . $DB->sanitize( $page_id_2 ). "'" );
            $DB->commit();
        }

        // Prepare to send back list ..
        // Set info about selected folder
        if( $fid ){
            $rs = $DB->select( K_TBL_FOLDERS, array('name'), "id='" . $DB->sanitize( $fid ). "'" );
            if( count($rs) ){
                $fname = $rs[0]['name'];
            }
        }
        $CTX->set( 'my_selected_fid', $fid, 'global' );
        $CTX->set( 'my_selected_fnamex', $fname, 'global' );
        $CTX->set( 'k_template_name', $tpl_name, 'global' );

        $snippet = 'manual_sort_inner.html'; //hardcoded??
        return $FUNCS->embed( $snippet );
    }
